fuel: Fix pattern matching and node ip extraction for sfc scenario
[releng.git] / jjb / fuel / fuel-deploy.sh
index 2ec5195..da08f31 100755 (executable)
@@ -1,4 +1,12 @@
 #!/bin/bash
+# SPDX-license-identifier: Apache-2.0
+##############################################################################
+# Copyright (c) 2016 Ericsson AB and others.
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Apache License, Version 2.0
+# which accompanies this distribution, and is available at
+# http://www.apache.org/licenses/LICENSE-2.0
+##############################################################################
 set -o errexit
 set -o nounset
 set -o pipefail
@@ -7,44 +15,118 @@ set -o pipefail
 source latest.properties
 
 # echo the info about artifact that is used during the deployment
-echo "Using $(echo $OPNFV_ARTIFACT_URL | cut -d'/' -f3) for deployment"
+echo "Using ${OPNFV_ARTIFACT_URL/*\/} for deployment"
+
+if [[ "$JOB_NAME" =~ "merge" ]]; then
+    # set simplest scenario for virtual deploys to run for merges
+    DEPLOY_SCENARIO="os-nosdn-nofeature-ha"
+else
+    # for none-merge deployments
+    # checkout the commit that was used for building the downloaded artifact
+    # to make sure the ISO and deployment mechanism uses same versions
+    echo "Checking out $OPNFV_GIT_SHA1"
+    git checkout $OPNFV_GIT_SHA1 --quiet
+fi
+
+# set deployment parameters
+export TMPDIR=$HOME/tmpdir
+BRIDGE=pxebr
+LAB_NAME=${NODE_NAME/-*}
+POD_NAME=${NODE_NAME/*-}
+
+if [[ "$NODE_NAME" == "opnfv-jump-2" ]]; then
+    LAB_NAME="lf"
+    POD_NAME="pod2"
+fi
+
+if [[ "$NODE_NAME" =~ "virtual" ]]; then
+    POD_NAME="virtual_kvm"
+fi
+
+# we currently support ericsson, intel, and lf labs
+if [[ ! "$LAB_NAME" =~ (ericsson|intel|lf) ]]; then
+    echo "Unsupported/unidentified lab $LAB_NAME. Cannot continue!"
+    exit 1
+else
+    echo "Using configuration for $LAB_NAME"
+fi
 
 # create TMPDIR if it doesn't exist
 export TMPDIR=$HOME/tmpdir
-[[ -d $TMPDIR ]] || mkdir -p $TMPDIR
+mkdir -p $TMPDIR
 
 # change permissions down to TMPDIR
 chmod a+x $HOME
 chmod a+x $TMPDIR
 
-# set CONFDIR, BRIDGE
-CONFDIR=$WORKSPACE/fuel/deploy/templates/hardware_environment/conf/linux_foundation_lab/pod2
-BRIDGE=pxebr
-
-# clone genesis repo and checkout the SR1 tag
-echo "Cloning genesis repo"
+# clone the securedlab repo
 cd $WORKSPACE
-GIT_SSL_NO_VERIFY=true git clone https://gerrit.opnfv.org/gerrit/genesis genesis
-cd genesis
-git checkout arno.2015.2.0
-
-# cleanup first
-sudo $WORKSPACE/genesis/common/ci/clean.sh -base_config $WORKSPACE/genesis/foreman/ci/inventory/lf_pod2_ksgen_settings.yml
+echo "Cloning securedlab repo ${GIT_BRANCH##origin/}"
+git clone ssh://jenkins-ericsson@gerrit.opnfv.org:29418/securedlab --quiet --branch ${GIT_BRANCH##origin/}
 
-# prepare for Fuel Deployment
-sudo $WORKSPACE/genesis/common/ci/setup.sh
+# construct the command
+DEPLOY_COMMAND="sudo $WORKSPACE/ci/deploy.sh -b file://$WORKSPACE/securedlab -l $LAB_NAME -p $POD_NAME -s $DEPLOY_SCENARIO -i file://$WORKSPACE/opnfv.iso -H -B $BRIDGE -S $TMPDIR"
 
 # log info to console
-echo "Starting the deployment using $INSTALLER. This could take some time..."
+echo "Deployment parameters"
+echo "--------------------------------------------------------"
+echo "Scenario: $DEPLOY_SCENARIO"
+echo "Lab: $LAB_NAME"
+echo "POD: $POD_NAME"
+echo "ISO: ${OPNFV_ARTIFACT_URL/*\/}"
+echo
+echo "Starting the deployment using $INSTALLER_TYPE. This could take some time..."
 echo "--------------------------------------------------------"
 echo
 
 # start the deployment
 echo "Issuing command"
-echo "sudo $WORKSPACE/fuel/ci/deploy.sh -iso $WORKSPACE/opnfv.iso -dea $CONFDIR/dea.yaml -dha $CONFDIR/dha.yaml -s $TMPDIR -b $BRIDGE -nh"
+echo "$DEPLOY_COMMAND"
+echo
 
-sudo $WORKSPACE/fuel/ci/deploy.sh -iso $WORKSPACE/opnfv.iso -dea $CONFDIR/dea.yaml -dha $CONFDIR/dha.yaml -s $TMPDIR -b $BRIDGE -nh
+$DEPLOY_COMMAND
 
 echo
 echo "--------------------------------------------------------"
-echo "Done!"
+echo "Deployment is done successfully!"
+
+# Quick and dirty fix for SFC scenatio - will be fixed properly post-release
+if [[ ! "$DEPLOY_SCENARIO" =~ "os-odl_l2-sfc" ]]; then
+    exit 0
+fi
+
+echo "SFC Scenario is deployed"
+
+# The stuff below is here temporarily and will be fixed once the release is out
+export FUEL_MASTER_IP=10.20.0.2
+export TACKER_SCRIPT_URL="https://git.opnfv.org/cgit/fuel/plain/prototypes/sfc_tacker/poc.tacker-up.sh?h=${GIT_BRANCH##*/}"
+export CONTROLLER_NODE_IP=$(sshpass -pr00tme /usr/bin/ssh -o UserKnownHostsFile=/dev/null \
+    -o StrictHostKeyChecking=no root@$FUEL_MASTER_IP 'fuel node list' | \
+    grep opendaylight | cut -d'|' -f5)
+
+# we can't do much if we do not have the controller IP
+if [[ ! "$CONTROLLER_NODE_IP" =~ "10.20.0" ]]; then
+    echo "Unable to retrieve controller IP"
+    exit 1
+fi
+
+echo "Copying and executing poc.tacker-up.sh script on controller node $CONTROLLER_NODE_IP"
+
+expect << END
+spawn /usr/bin/ssh -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no root@\$env(FUEL_MASTER_IP)
+expect {
+  -re ".*sword.*" {
+    exp_send "r00tme\r"
+  }
+}
+expect "# "
+send "/usr/bin/ssh -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no root@\$env(CONTROLLER_NODE_IP)\r"
+expect "# "
+send "/usr/bin/curl -o /root/poc.tacker-up.sh \$env(TACKER_SCRIPT_URL)\r"
+expect "# "
+send "/bin/bash /root/poc.tacker-up.sh\r"
+expect "# "
+send "exit\r"
+expect "# "
+send "exit\r"
+END